 #include <sstream>

 #include "YUI.h"
 #include "YApplication.h"
 #include "YWidgetFactory.h"
 #include "YDialog.h" 
 #include "YLayoutBox.h"
 #include "YEvent.h"
 #include "YTable.h"
 #include "YTableHeader.h"
 #include "YCheckBoxFrame.h"
 #include "YWidget.h"
 #include "YTimeField.h"
 #include "YAlignment.h"



 #include "YUILoader.h"

#define LAYOUT_HELPER_CONVENIENCE( AL ) \
	inline YWidget * at##AL ( YWidget * w ) { return YUI::widgetFactory()->create##AL( w ); }
LAYOUT_HELPER_CONVENIENCE( Left );
LAYOUT_HELPER_CONVENIENCE( Right );
LAYOUT_HELPER_CONVENIENCE( Top );
LAYOUT_HELPER_CONVENIENCE( Bottom );
LAYOUT_HELPER_CONVENIENCE( HCenter );
LAYOUT_HELPER_CONVENIENCE( VCenter );
LAYOUT_HELPER_CONVENIENCE( HVCenter );

 int main( int argc, char **argv )
 {
     YUI::app()->iconLoader()->addIconSearchPath("/home/angelo/src/ManaTools/dnfdragora/share/images/");
     std::string icon = YUI::app()->iconLoader()->findIcon("32x32/dnfdragora.png");
     YUI::app()->setApplicationIcon(icon);
     YDialog    * dialog = YUI::widgetFactory()->createPopupDialog();
     YLayoutBox * vbox   = YUI::widgetFactory()->createVBox( dialog );
     YUI::widgetFactory()->createLabel     ( vbox, "YTable test" );

     YWidget *  frame  = YUI::widgetFactory()->createCheckBoxFrame( vbox, "Table", false );
{
	frame->setWeight( YD_HORIZ, 1 );
	frame               = YUI::widgetFactory()->createHVCenter( frame );
	frame               = YUI::widgetFactory()->createVBox( frame );

	YTableHeader* head           = new YTableHeader;
	head->addColumn( "Right", YAlignEnd );
	head->addColumn( "Center", YAlignCenter );
	head->addColumn( "Left", YAlignBegin );
	YTable* table          = YUI::widgetFactory()->createTable( atLeft(frame), head );
	table->setNotify( true );

	YItemCollection items;
	items.push_back( new YTableItem( "a", "b", "c", "extra" ) );
	items.push_back( new YTableItem( "aa", "bb", "cc" ) );
	items.push_back( new YTableItem( "aaa", "bbb", "ccc" ) );
	items.push_back( new YTableItem( "aaaa", "bbbb", "cccc" ) );
	items.push_back( new YTableItem( "aaaaa", "bbbbb", "ccccc" ) );
	items.push_back( new YTableItem( "aaaaaa", "bbbbbb", "cccccc" ) );
	table->addItems( items ); // This is more efficient than repeatedly calling cbox->addItem
}

 YUI::widgetFactory()->createPushButton( vbox, "&OK" );

     dialog->waitForEvent();
     dialog->destroy();
 }
